/* Rexx */
/* Sortiert die Datei CONFIG.SYS
   Copyright (c) 1997-2000 by Stefan Milcke
                              Kferstrae 45
                              28779 Bremen

   Dieses Rexx-Script ist Freeware
   Datum der Erstellung: 03.07.1997
   Letzte Aenderung am:  23.08.1998
*/

/* Preset Variables */

Parse Arg CfgFile

/* If no parameter was given, assume \CONFIG.SYS */
If Length(CfgFile)=0 Then
Do
 CfgFile="\CONFIG.SYS"
End
TempCfg="\CONFIG.NEW"

Call RxFuncAdd 'SysLoadFuncs','RexxUtil','SysLoadFuncs'
Call RxFuncAdd 'SysFileDelete','RexxUtil','SysFileDelete'
Call RxFuncAdd 'SysTempFileName','RexxUtil','SysTempFileName'

/* CONFIG.SYS einlesen */
i=1
IFile=Stream(CfgFile,"C","OPEN READ")
Do Forever
 If Lines(CfgFile)=0 Then Leave
 CfgLine.i=Linein(CfgFile)
 If (Left(CfgLine.i,20)="REM ****************") | (Left(CfgLine.i,6)="REM : ") Then
  Nop
 Else
  i=i+1
 CfgLine.0=i
End
IFile=Stream(CfgFile,"C","CLOSE")

/* ggf. Temporre Datei lschen */
FileThere=Stream(TempCfg,"C","QUERY EXISTS")
If Length(FileThere)>0 Then
 Call SysFileDelete TempCfg

/* Temporre Datei ffnen */
OFile=Stream(TempCfg,"C","OPEN WRITE")

/* IFS einsortieren */
/* Zuerst einen Remark einfgen */
Call AddRemark "Installable File Systems (IFS)"
Call GetUnsorted "IFS"
Call WriteFoundArray
rc=LineOut(TempCfg,"")

/* Base Devices einsortieren */
/* Zuerst einen Remark einfgen */
Call AddRemark "Base Devices"
Call GetUnsorted "BASEDEV"
Call WriteFoundArray
rc=LineOut(TempCfg,"")

/* SET statements einsortieren */
Call AddRemark "Environment variables"
Call GetUnsorted "SET "
Call SortFoundArray
Call WriteFoundArray
rc=LineOut(TempCfg,"")

/* Devices einsortieren */
Call AddRemark "Devices"
Call GetUnsortedAndWriteFoundArray "DEVICE"
rc=LineOut(TempCfg,"")

/* Alle bekannten OS/2 statements einsortieren */
Call AddRemark "OS2 Statements"
Call GetUnsortedAndWriteFoundArray "AUTOFAIL"
Call GetUnsortedAndWriteFoundArray "BUFFERS"
Call GetUnsortedAndWriteFoundArray "CLOCKSCALE"
Call GetUnsortedAndWriteFoundArray "CODEPAGE"
Call GetUnsortedAndWriteFoundArray "COUNTRY"
Call GetUnsortedAndWriteFoundArray "DEVINFO"
Call GetUnsortedAndWriteFoundArray "DISKCACHE"
Call GetUnsortedAndWriteFoundArray "IOPL"
Call GetUnsortedAndWriteFoundArray "LIBPATH"
Call GetUnsortedAndWriteFoundArray "MAXWAIT"
Call GetUnsortedAndWriteFoundArray "MEMMAN"
Call GetUnsortedAndWriteFoundArray "PAUSEONERROR"
Call GetUnsortedAndWriteFoundArray "PRINTMONBUFSIZE"
Call GetUnsortedAndWriteFoundArray "PRIORITY_DISK_IO"
Call GetUnsortedAndWriteFoundArray "PROTECTONLY"
Call GetUnsortedAndWriteFoundArray "PROTSHELL"
Call GetUnsortedAndWriteFoundArray "RESERVEDRIVELETTER"
Call GetUnsortedAndWriteFoundArray "SUPPRESSPOPUPS"
Call GetUnsortedAndWriteFoundArray "SWAPPATH"
Call GetUnsortedAndWriteFoundArray "THREADS"
Call GetUnsortedAndWriteFoundArray "VIRTUALADDRESSLIMIT"
rc=LineOut(TempCfg,"")

/* Alle bekannten DOS statements einsortieren */
Call AddRemark "DOS Statements"
Call GetUnsortedAndWriteFoundArray "FILES"
Call GetUnsortedAndWriteFoundArray "BREAK"
Call GetUnsortedAndWriteFoundArray "SHELL"
Call GetUnsortedAndWriteFoundArray "FCBS"
Call GetUnsortedAndWriteFoundArray "RMSIZE"
Call GetUnsortedAndWriteFoundArray "DOS"
rc=LineOut(TempCfg,"")

/* RUN und CALL anweisungen einsortieren */
Call AddRemark "Run And Call"
Call GetUnsortedRunAndCall
Call WriteFoundArray
rc=LineOut(TempCfg,"")

/* Rest unter unbekannt einsortieren */
Call AddRemark "Unknown"
Call WriteUnmatched

/* Datei schlieen */
OFile=Stream(TempCfg,"C","CLOSE")
Exit

SortFoundArray:
 Do i=1 To Found.0
  L1=Found.i
  If Left(L1,4)="REM " Then
  Do
   L1=Right(L1,Length(L1)-4)
  End
  Do j=i To Found.0
   L2=Found.j
   If Left(L2,4)="REM " Then
   Do
    L2=Right(L2,Length(L2)-4)
   End
   If L1>L2 Then
   Do
    T=Found.i
    Found.i=Found.j
    Found.j=T
    L1=Found.i
    If Left(L1,4)="REM " Then
    Do
     L1=Right(L1,Length(L1)-4)
    End
   End
  End
 End
Return

WriteFoundArray:
 Do i=1 To Found.0
  rc=LineOut(TempCfg,Found.i)
 End
Return
 
GetUnsorted:
 Sea1=Arg(1)
 Sea2="REM "Arg(1)
 Found.0=0
 j=0
 Excep=0
 Do i=1 To CfgLine.0
  Line=CfgLine.i
  If (Translate(Left(Line,Length(Sea1)))=Translate(Sea1)) | (Translate(Left(Line,Length(Sea2)))=Translate(Sea2)) Then
  Do
   If Sea1=='IFS' Then
   Do
    If Pos('NETWKSTA.200',Line)>0 Then
    Do
     Excep=1
    End
   End
   If Excep=0 Then
   Do
    j=j+1
    Found.j=Line
    CfgLine.i=""
   End
  End
 End
 Found.0=j
Return

GetUnsortedRunAndCall:
 Sea1="RUN"
 Sea2="REM RUN"
 Sea3="CALL"
 Sea4="REM CALL"
 Found.0=0
 j=0
 Do i=1 To CfgLine.0
  Line=CfgLine.i
  If (Left(Line,Length(Sea1))=Sea1) | (Left(Line,Length(Sea2))=Sea2) | (Left(Line,Length(Sea3))=Sea3) | (Left(Line,Length(Sea4))=Sea4) Then
  Do
   j=j+1
   Found.j=Line
   CfgLine.i=""
  End
 End
 Found.0=j
Return

GetUnsortedAndWriteFoundArray:
 SEA=Arg(1)
 Call GetUnsorted SEA
 Call WriteFoundArray
Return

WriteUnmatched:
 Do i=1 To CfgLine.0-1
  If CfgLine.i="" Then
   Nop
  Else
   rc=LineOut(TempCfg,CfgLine.i)
 End
Return


AddRemark:
Call AddRemarkLine
rc=LineOut(TempCfg,"REM : "Arg(1)":")
Call AddRemarkLine
Return

AddRemarkLine:
rc=LineOut(TempCfg,"REM ***************************************************************************")
Return
